Status: Closed

Priority: High

Assignee:

Category: Processing/QGIS

Affected QGIS version:master Regression?:

Operating System: Easy fix?:

Pull Request or Patch supplied:Yes Resolution: fixed

Crashes QGIS or corrupts data:No Copied to github as #: 15424

Description

When creating convex hulls from a point layer (.shp) based on a common attribute ("create convex hulls based on input field"), one would

expect that the resulting polygon layer would at least contain this attribute in the table.

But in opposite to this, the resulting table structure is just a complete copy of the points attributes table and most of its fields are empty (of

course, cause most point values differ). 

Two fields get populated though, but only with strange numbers which i can't identify.

This behaviour reduces the usability of convex hull enormously, cause i planned to use them as a coverage layer for Atlas and fill the map

title with the attribute from the convex hull layer without extra steps ... would all be a real time saver for 300 + x overview maps!

p.s. The closed bug #2529 is similar, but explicitly refers to postgis

pps.: just managed to retrieve my attribute in the table by deleting the first column in my point shape: Now the first column in the polygon

layer represents the chosen attribute (3rd column in point layer), field name is of course still wrong.

Associated revisions

Revision f8e2cacf - 2013-07-14 04:51 PM - Daniel Vaz

Fix #6063

Revision 8a50ddb9 - 2013-07-14 04:51 PM - Daniel Vaz

Fix #6063

Revision 033440fc - 2013-09-12 06:41 PM - Alexander Bruy

Merge pull request #731 from ddanielvaz/bugfix-6063

Preserve attributes in Convex Hull (fix #6063)

History

#1 - 2012-08-03 10:14 AM - Salvatore Larosa

Confirmed!

If "create convex hulls based on input field" is checked the tool write the values ​​in the first three fields without changing the name!
Values ​​are the ID, area and perimeter of the polygon!

It should create new fields!

#2 - 2012-09-04 12:07 PM - Paolo Cavallini

- Target version set to Version 2.0.0

#3 - 2013-04-25 08:59 AM - Fabian Stenzel

Still using Version 1.8 of QGIS (standard packages for ubuntu), I can't say if this issue is fixed by now, but I had the same problem, missing/losing the

attribute I based my convex hull on.

As Salvatore mentioned, it seems that the newly created convex_hull_shape copies all fields of the old table, but overwrites the first three columns in the

creation process with: convexHull_based_field(TYPE),Area(FLOAT),Perimeter(FLOAT) regardless of the types the actual first three fields have.

Converting from Float to Integer or String seems to work fine, but if the first field is an Integer (what the ID field usually is) and the convex_hull was based

on a String-field the content the convex-hull was based on gets lost.

Work around: use table-manager, create 3 new fields before all the others with the Types: convex_hull_based_field_type,Float,Float.

#4 - 2013-07-13 10:25 AM - Giovanni Manghi

- Subject changed from Geoprocessing -> Convex hull(s): Attributes not properly handled to ftools "Convex hull(s)": Attributes not properly handled

- Priority changed from Normal to High

raising the priority because it produces wrong results.

#5 - 2013-07-13 10:28 AM - Giovanni Manghi

- Subject changed from ftools "Convex hull(s)": Attributes not properly handled to ftools "Convex hull(s)": wrong attributes in output

#6 - 2013-07-13 05:29 PM - Daniel Vaz

What is the supposed behavior of convex hull when create convex hulls based on input field?

Please, give some dataset and correct supposed behavior.

Thank you

#7 - 2013-07-14 01:12 AM - Giovanni Manghi

- Resolution set to fixed

- Status changed from Open to Closed

Daniel Vaz wrote:

What is the supposed behavior of convex hull when create convex hulls based on input field?

Please, give some dataset and correct supposed behavior.

Thank you

2025-04-26 2/4



and again... today it seems to work ok... sorry (again) for the noise.

#8 - 2013-07-14 07:09 AM - Daniel Vaz

- Status changed from Closed to Reopened

I think that issues was not solved in #8219.

I am working in a bugfix for it.

Please, if anybody has some dataset to test the convex hull tool, I will appreciate.

Thanks in advance

#9 - 2013-07-14 08:01 AM - Daniel Vaz

Please Giovanni and Bernd Vogelgesang, can you try https://github.com/qgis/Quantum-GIS/pull/731 ?

Thanks

#10 - 2013-07-14 09:14 AM - Giovanni Manghi

- Status changed from Reopened to In Progress

- Resolution deleted (fixed)

- Pull Request or Patch supplied changed from No to Yes

Daniel Vaz wrote:

Please Giovanni and Bernd Vogelgesang, can you try https://github.com/qgis/Quantum-GIS/pull/731 ?

Thanks

I will ASAP. What exactly does fix your patch? Today it seemed to work ok.

#11 - 2013-07-14 09:29 AM - Daniel Vaz

It fixes the field populate proccess, reported in description and by Fabian Stenzel.

#12 - 2013-08-08 03:06 AM - Alexander Bruy

Hmm... for me current implementation works fine

#13 - 2013-08-08 03:50 AM - Bernd Vogelgesang

made 3 quick tests in 1.9 with common attribute as integer, real and text, and all looks correct.

Thanx a lot.
#14 - 2013-08-17 10:27 AM - Daniel Vaz

- File polygons.zip added

Choose Vector -> Geoprocessing -> Convex Hull -> Create a convex hull based on input field -> Choose any field -> Click Ok

The generated convex hull polygons don't preserve the parent(s) field(s) polygon(s).

The patch fix it.

Thanks in advance

#15 - 2013-09-12 09:41 AM - Alexander Bruy

- Status changed from In Progress to Closed

Fixed in changeset commit:"033440fcfe9e9c46a0fa75de7c76561e1864f282".

#16 - 2013-09-12 09:42 AM - Alexander Bruy

- Resolution set to fixed

#17 - 2017-05-01 01:22 AM - Giovanni Manghi

The "ftools" category is being removed from the tracker, changing the category of this ticket to "Processing/QGIS" to not leave the category orphaned.

Files

Clipboard01.jpg 45.6 KB 2012-07-18 Bernd Vogelgesang

Clipboard02.jpg 63.7 KB 2012-07-18 Bernd Vogelgesang

polygons.zip 1.91 KB 2013-08-17 Daniel Vaz
